/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package lidaws3d.featuredetectors;

import edu.memphis.ccrg.lida.pam.PamLinkable;
import edu.memphis.ccrg.lida.pam.tasks.DetectionAlgorithm;
import edu.memphis.ccrg.lida.pam.tasks.MultipleDetectionAlgorithm;
import java.util.HashMap;
import java.util.Map;

/**
 *
 * @author jucah
 */
public class EnergyDetector extends MultipleDetectionAlgorithm implements DetectionAlgorithm {

    private PamLinkable enoughEnergy;
    private PamLinkable lowEnergy;
    private final String modality = "";
    private Map<String, Object> detectorParams = new HashMap<>();

    @Override
    public void init() {
        super.init();
        enoughEnergy = pamNodeMap.get("enoughEnergy");
        lowEnergy = pamNodeMap.get("lowEnergy");
        detectorParams.put("mode", "energyLevel");
    }

    @Override
    public void detectLinkables() {
        double energyLevel = (Double) sensoryMemory.getSensoryContent(modality, detectorParams);
        if (energyLevel <= 400.0) {
            pam.receiveExcitation(lowEnergy, 1.0);
        } else {
            pam.receiveExcitation(enoughEnergy, 1.0);
        }
    }
}
