/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package lidaws3d.modules;

import edu.memphis.ccrg.lida.sensorymemory.SensoryMemoryImpl;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;
import ws3dproxy.model.Thing;

/**
 *
 * @author jucah
 */
public class SensoryMemory extends SensoryMemoryImpl {

    private static final Logger logger = Logger.getLogger(SensoryMemory.class.getCanonicalName());
    private Map<String, Object> sensorParam;
    private boolean done;
    private double energyLevel;
    private Thing food;
    private Thing jewel;
    private List<Thing> thingsAhead;
    private Thing leafletJewel;
    private Map<Long, Integer> completeLeaflets;

    public SensoryMemory() {
        this.sensorParam = new HashMap<>();
        this.done = false;
        this.energyLevel = 0.0;
        this.food = null;
        this.jewel = null;
        this.thingsAhead = new ArrayList<>();
        this.leafletJewel = null;
        this.completeLeaflets = new HashMap<>();
    }

    @SuppressWarnings("unchecked")
    @Override
    public void runSensors() {
        logger.log(Level.INFO, "[runSensors] Called.");
        sensorParam.clear();
        sensorParam.put("mode", "done");
        done = (boolean) environment.getState(sensorParam);
        sensorParam.clear();
        sensorParam.put("mode", "energyLevel");
        energyLevel = (double) environment.getState(sensorParam);
        sensorParam.clear();
        sensorParam.put("mode", "food");
        food = (Thing) environment.getState(sensorParam);
        sensorParam.clear();
        sensorParam.put("mode", "jewel");
        jewel = (Thing) environment.getState(sensorParam);
        sensorParam.clear();
        sensorParam.put("mode", "thingsAhead");
        thingsAhead = (List<Thing>) environment.getState(sensorParam);
        sensorParam.clear();
        sensorParam.put("mode", "leafletJewel");
        leafletJewel = (Thing) environment.getState(sensorParam);
        sensorParam.clear();
        sensorParam.put("mode", "completeLeaflets");
        completeLeaflets = (Map<Long, Integer>) environment.getState(sensorParam);
    }

    @Override
    public Object getSensoryContent(String modality, Map<String, Object> params) {
        Object requestedObject = null;
        String mode = (String) params.get("mode");
        switch (mode) {
            case "done":
                requestedObject = done;
                break;
            case "energyLevel":
                requestedObject = energyLevel;
                break;
            case "food":
                requestedObject = food;
                break;
            case "jewel":
                requestedObject = jewel;
                break;
            case "thingsAhead":
                requestedObject = thingsAhead;
                break;
            case "leafletJewel":
                requestedObject = leafletJewel;
                break;
            case "completeLeaflets":
                requestedObject = completeLeaflets;
                break;
            default:
                logger.log(Level.WARNING, "[getSensoryContent] Unknown mode requested: {0}.", mode);
                break;
        }
        logger.log(Level.INFO, "[getSensoryContent] Mode requested: {0}; object returned: {1}.", new Object[]{mode, requestedObject});
        return requestedObject;
    }

    @Override
    public Object getModuleContent(Object... os) {
        return null;
    }

    @Override
    public void decayModule(long ticks) {
        // NA
    }
}
